<template>
    <div class="home" style="width: 100%; height: 100%">
        <v-card width="500" class="mx-auto mt-9">
            <v-card-title>{{ $t("LNG_LOGIN_TITLE") }}</v-card-title>
            <v-form ref="form">
                <v-card-text>
                    <v-text-field v-model="login"
                                  :label="$t('LNG_LOGIN_LOGIN')"
                                  prepend-icon="mdi-account-circle"
                                  :rules="[v => !!v || $t('LNG_LOGIN_INPUT') ]"
                                  required/>

                    <v-text-field v-model="password"
                                  :label="$t('LNG_LOGIN_PASSWORD')"
                                  prepend-icon="mdi-lock"
                                  :type="displayPassword ? 'text' : 'password'"
                                  :append-icon="displayPassword ? 'mdi-eye' : 'mdi-eye-off'"
                                  @click:append="displayPassword = !displayPassword"
                                  :rules="[v => !!v || $t('LNG_LOGIN_INPUT') ]"
                                  required/>
                </v-card-text>
                <v-card-actions>
                    <v-btn :disabled="login.length === 0 && password.length === 0" type="submit" class="mx-auto"
                           color="info" :loading="loading" @click="CASlogin">
                        {{ $t("LNG_LOGIN_CNX") }}
                    </v-btn>
                </v-card-actions>
            </v-form>
        </v-card>
        <v-alert v-show="msg != null" elevation="24" type="error" class="mx-auto mt-9" style="width: 500px">
            {{ msg }}
        </v-alert>
    </div>
</template>

<script>
import Services from "@/services/api";
import { LOGIN } from "@/store/actions.type";
import { SET_USER } from "@/store/mutations.type";

export default {
    name: 'Login',
    data: () => ({
        login: "",
        password: "",
        msg: null,
        displayPassword: false,
        loading: false
    }),
    methods: {
        CASlogin: async function () {
            this.loading = true;
            if (this.$refs.form.validate()) {
                let req = await Services.login(this.login, this.password);
                switch (req.status) {
                    case 200: {
                        let token = await req.text();
                        await this.$store.dispatch(LOGIN, {
                            token: token
                        });
                        let user = await Services.getUser();
                        this.$store.commit(SET_USER, user);
                        setTimeout(async () => {
                            await this.$router.push({ name: "Fields" })
                        }, 1000);
                        break;
                    }
                    case 401: {
                        this.msg = this.$t("LNG_LOGIN_401");
                        break;
                    }
                    case 500: {
                        this.msg = this.$t("LNG_LOGIN_500");
                        break;
                    }
                    default: {
                        this.msg = this.$t("LNG_LOGIN_UNKNOWN");
                        break;
                    }
                }
            }
            this.loading = false;
        }
    },
    async mounted() {
        Services.getUser(false).then(async res => {
            switch (res.status) {
                case 200:
                    this.$store.commit(SET_USER, await res.json());
                    await this.$router.push({ name: "Fields" });
                    break;

            }
        });
    }
}
</script>
